<script>
// Import the basic building blocks
import {
    Editor,
    EditorContent
} from "tiptap";
import {
    Blockquote,
    BulletList,
    CodeBlock,
    HardBreak,
    Heading,
    ListItem,
    OrderedList,
    HorizontalRule,
    TodoItem,
    TodoList,
    Bold,
    Code,
    Italic,
    Link,
    Strike,
    Underline,
    History,
} from "tiptap-extensions";
//componnet
import MenuBar from "@/components/tooltip/tooltip-editor_menu_bar";
export default {
    props: {
        path: {
            type: String,
            default: "edit",
        },
        item: {
            type: [Array, Object],
            default: () => [],
        },
        vuexCommit: {
            type: String,
            default: "UPDATE_SECONDARYCOMPONENT_VALUE",
        },
    },
    components: {
        EditorContent,
        MenuBar,
    },
    methods: {
        setContent() {
            this.editor.setContent(this.item.content.data, true);
        },
    },
    data() {
        return {
            editor: null,
            json: "",
            html: "",
            tool: [
                "bold",
                "italic",
                "strike",
                "underline",
                "code",
                "paragraph",
                {
                    heading: [1, 2, 3],
                },
                "bullet_list",
                "ordered_list",
                "blockquote",
                "horizontal_rule",
                "undo",
                "redo",
            ],
        };
    },
    mounted() {
        this.editor = new Editor({
            extensions: [
                new HorizontalRule(),
                new Blockquote(),
                new BulletList(),
                new CodeBlock(),
                new HardBreak(),
                new Heading({
                    levels: [1, 2, 3],
                }),
                new ListItem(),
                new OrderedList(),
                new TodoItem(),
                new TodoList(),
                new Link(),
                new Bold(),
                new Code(),
                new Italic(),
                new Strike(),
                new Underline(),
                new History(),
            ],
            content: "<p></p>",
            editable: this.path == "edit" ? true : false,
            disablePasteRules: true,
            autoFocus: false,
            onDrop(view, event, slice, moved) {
                return !moved;
            },
            onUpdate: ({
                getJSON,
                getHTML
            }) => {
                this.$store.commit(this.vuexCommit, {
                    key: this.item.id,
                    second_key: "data",
                    val: getJSON(),
                });
            },
        });

        this.setContent();
    },
    render(h) {
        let vm = this;
        let bar = h(MenuBar, {
            props: {
                editor: vm.editor,
                tool: vm.tool,
            },
        });
        let content = h(EditorContent, {
            class: ["editor__content"],
            props: {
                editor: vm.editor,
            },
        });
        return h("div", [bar, content]);
    },
    beforeDestroy() {
        this.editor.destroy();
    },
};
</script>

<style lang="scss">
$color-black: #000000;
$color-white: #ffffff;
$color-grey: #dddddd;

.editor {
    position: relative;
    max-width: 30rem;
    margin: 0 auto 5rem auto;

    &__content {
        overflow-wrap: break-word;
        word-wrap: break-word;
        word-break: break-word;

        * {
            caret-color: currentColor;
        }

        pre {
            padding: 0.7rem 1rem;
            border-radius: 5px;
            background: $color-black;
            color: $color-white;
            font-size: 0.8rem;
            overflow-x: auto;

            code {
                display: block;
            }
        }

        p code {
            padding: 0.2rem 0.4rem;
            border-radius: 5px;
            font-size: 0.8rem;
            font-weight: bold;
            background: rgba($color-black, 0.1);
            color: rgba($color-black, 0.8);
        }

        ul,
        ol {
            padding-left: 1rem;
        }

        li>p,
        li>ol,
        li>ul {
            margin: 0;
        }

        a {
            color: inherit;
        }

        blockquote {
            border-left: 3px solid rgba($color-black, 0.1);
            color: rgba($color-black, 0.8);
            padding-left: 0.8rem;
            font-style: italic;

            p {
                margin: 0;
            }
        }

        img {
            max-width: 100%;
            border-radius: 3px;
        }

        table {
            border-collapse: collapse;
            table-layout: fixed;
            width: 100%;
            margin: 0;
            overflow: hidden;

            td,
            th {
                min-width: 1em;
                border: 2px solid $color-grey;
                padding: 3px 5px;
                vertical-align: top;
                box-sizing: border-box;
                position: relative;

                >* {
                    margin-bottom: 0;
                }
            }

            th {
                font-weight: bold;
                text-align: left;
            }

            .selectedCell:after {
                z-index: 2;
                position: absolute;
                content: "";
                left: 0;
                right: 0;
                top: 0;
                bottom: 0;
                background: rgba(200, 200, 255, 0.4);
                pointer-events: none;
            }

            .column-resize-handle {
                position: absolute;
                right: -2px;
                top: 0;
                bottom: 0;
                width: 4px;
                z-index: 20;
                background-color: #adf;
                pointer-events: none;
            }
        }

        .tableWrapper {
            margin: 1em 0;
            overflow-x: auto;
        }

        .resize-cursor {
            cursor: ew-resize;
            cursor: col-resize;
        }
    }
}
</style>
